<?php  

defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

class SkybluesofaCssShareBlockController
		extends BlockController
{

	var $pobj;
	protected $btTable = 'btSkybluesofaCssShare';
	protected $btNetworksTable = 'btSkybluesofaCssSharedNetworks';
	protected $btInterfaceWidth = "580";
	protected $btInterfaceHeight = "450";
	protected $btWrapperClass = 'ccm-ui';
	protected $db = null;
	protected $thumbnail_handle = array('page_thumbnail', 'thumbnail');

	/**
	 * Used for localization. If we want to localize the name/description we have to include this
	 */
	public function getBlockTypeDescription()
	{
		return t("Displays social sharing buttons on your site using only HTML and JavaScript");
	}

	public function getBlockTypeName()
	{
		return t("CSS Share");
	}

	public function __construct($obj = null)
	{
		parent::__construct($obj);
		$this->db = Loader::db();
	}

	public function view()
	{
		/*
		  To hard code the block:
		  $cssShare = BlockType::getByHandle('skybluesofa_css_share');

		  Then use this for each network you wish to share:
		  $cssShare->controller->sharedNetworks[] = array('network'=>'digg','title'=>'','description'=>'','pin_media'=>'');


		 */
		$pkg = Loader::package('skybluesofa_social_share');
		echo "<!-- CSS Share v" . $pkg->getPackageVersion() . " by Sky Blue Sofa -->";
		if (empty($this->layout))
			$this->layout = 'horizontal';
		$this->set('layout', $this->layout);
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', isset($this->sharedNetworks) ? $this->sharedNetworks : $this->getSharedNetworks($this->bID));
		$this->set('bID', isset($this->bID) ? $this->bID : rand(1000000, 9999999));
		if (isset($this->style_glossy))
			$this->set('style_glossy', $this->style_glossy);
		if (isset($this->style_embossed))
			$this->set('style_embossed', $this->style_embossed);
		if (isset($this->style_border))
			$this->set('style_border', $this->style_border);
		if (isset($this->style_pressed))
			$this->set('style_pressed', $this->style_pressed);
		if (isset($this->style_corners))
			$this->set('style_corners', $this->style_corners);
		if (isset($this->size))
			$this->set('size', $this->size);
		if (isset($this->connect_size))
			$this->set('connect_size', $this->connect_size);
		if (isset($this->icon_type))
			$this->set('icon_type', $this->icon_type);

		$currentPage = Page::getCurrentPage();
		Loader::helper('navigation');

		$this->set('sbsss_cID', $currentPage->getCollectionID());
		$this->set('sbsss_pageURL', NavigationHelper::getLinkToCollection($currentPage, true));
		$this->set('sbsss_pageTitle', $currentPage->getCollectionAttributeValue('meta_title') ? $currentPage->getCollectionAttributeValue('meta_title') : $currentPage->getCollectionName());
		$this->set('sbsss_pageDescription', $currentPage->getCollectionAttributeValue('meta_description') ? str_replace(array("\r\n", "\n", "\r", "  "), " ", $currentPage->getCollectionAttributeValue('meta_description')) : '');
		$this->set('pinterest_image', $this->getPageThumbnail());
	}

	function add()
	{
		if (empty($this->floating_offset))
			$this->floating_offset = "0";
		$this->set('floating_offset', $this->floating_offset);
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('pinterest_image', $this->getPageThumbnail());
	}

	function edit()
	{
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('pinterest_image', $this->getPageThumbnail());
	}

	function getPageThumbnail()
	{
		Loader::model('file');
		$currentPage = Page::getCurrentPage();
		foreach ($this->thumbnail_handle as $thumbnail_handle) {
			$thumbnail = $currentPage->getAttribute($thumbnail_handle);
			if (is_object($thumbnail)) {
				$fID = $thumbnail->getFileID();
				$imageUrl = BASE_URL . File::getRelativePathFromID($fID);
				if ($imageUrl)
					return $imageUrl;
			}
		}
		return false;
	}

	/*
	 * save block config
	 */

	public function save($args)
	{
		$args['floating_offset'] = empty($args['floating_offset']) ? '0' : $args['floating_offset'];
		parent::save($args);
		$this->saveSharedNetworks($this->bID, $args);
	}

	function duplicate($newBID)
	{
		parent::duplicate($newBID);
		$this->duplicateSharedNetworks($newBID);
	}

	public function getSharedNetworks($bID)
	{
		$po = $this->db->GetArray("SELECT * FROM " . $this->btNetworksTable . " WHERE ordinal IS NOT NULL AND bID = ? ORDER BY ordinal", array($bID));
		$no = $this->db->GetArray("SELECT * FROM " . $this->btNetworksTable . " WHERE ordinal IS NULL AND bID = ? ORDER BY connID", array($bID));
		$res = array_merge($po, $no);
		foreach ($res as $key => $sharedNetwork) {
			$currentPage = Page::getCurrentPage();
			if (empty($sharedNetwork['url'])) {
				Loader::helper('navigation');
				$res[$key]['url'] = NavigationHelper::getLinkToCollection($currentPage, true);
			}
			if (empty($sharedNetwork['description'])) {
				$res[$key]['description'] = $currentPage->getCollectionDescription();
			}
		}
		return $res;
	}

	public function saveSharedNetworks($bID, $args)
	{
		if (!isset($args['sharedNetworks']) || !is_array($args['sharedNetworks'])) {
			return false;
		}
		$this->deleteSharedNetworks($bID);
		$ordinal = 1;

		$networkHandles = array();
		foreach ($this->getNetworks() as $network) {
			if ($network['active']) {
				$networkHandles[] = $network['handle'];
			}
		}
		foreach ($args['sharedNetworks']['network'] as $key => $value) {
			if ($key && !empty($args['sharedNetworks']['network'][$key])) {
				if (in_array($args['sharedNetworks']['network'][$key], $networkHandles)) {
					$sharedNetwork['bID'] = $bID;
					$sharedNetwork['ordinal'] = $ordinal;
					$sharedNetwork['network'] = $args['sharedNetworks']['network'][$key];
					$sharedNetwork['title'] = $args['sharedNetworks']['title'][$key];
					$sharedNetwork['url'] = $args['sharedNetworks']['url'][$key];
					$sharedNetwork['description'] = $args['sharedNetworks']['description'][$key];
					$sharedNetwork['pin_media'] = $args['sharedNetworks']['pin_media'][$key];
					$sharedNetwork['background'] = $args['sharedNetworks']['background'][$key];
					$sharedNetwork['custom_background'] = $args['sharedNetworks']['custom_background'][$key];
					$sharedNetwork['icon'] = $args['sharedNetworks']['icon'][$key];
					$this->addSharedNetwork($bID, $sharedNetwork);
					$ordinal++;
				}
			}
		}
	}

	function duplicateSharedNetworks($newBID)
	{
		$b = $this->getBlockObject();
		$c = $b->getBlockCollectionObject();

		$res = $this->db->query("select * from " . $this->btTable . " where bID = ?", array($this->bID));
		$existingBlock = $res->fetchRow();

		if (count($existingBlock) > 0) {
			$oldBID = $existingBlock['bID'];

			$res = $this->db->GetArray("SELECT * FROM " . $this->btNetworksTable . " WHERE bID=?", array($this->bID));
			$existingSharedNetworks = array('sharedNetworks' => array());
			$existingSharedNetworks['sharedNetworks']['network'][] = null;
			$existingSharedNetworks['sharedNetworks']['title'][] = null;
			$existingSharedNetworks['sharedNetworks']['url'][] = null;
			$existingSharedNetworks['sharedNetworks']['pin_media'][] = null;
			$existingSharedNetworks['sharedNetworks']['description'][] = null;
			$existingSharedNetworks['sharedNetworks']['background'][] = null;
			$existingSharedNetworks['sharedNetworks']['custom_background'][] = null;
			$existingSharedNetworks['sharedNetworks']['icon'][] = null;
			foreach ($res as $key => $sharedNetwork) {
				$existingSharedNetworks['sharedNetworks']['network'][] = $sharedNetwork['network'];
				$existingSharedNetworks['sharedNetworks']['title'][] = $sharedNetwork['title'];
				$existingSharedNetworks['sharedNetworks']['url'][] = $sharedNetwork['url'];
				$existingSharedNetworks['sharedNetworks']['pin_media'][] = $sharedNetwork['pin_media'];
				$existingSharedNetworks['sharedNetworks']['description'][] = $sharedNetwork['dg_description'];
				$existingSharedNetworks['sharedNetworks']['background'][] = $sharedNetwork['background'];
				$existingSharedNetworks['sharedNetworks']['custom_background'][] = $sharedNetwork['custom_background'];
				$existingSharedNetworks['sharedNetworks']['icon'][] = $sharedNetwork['icon'];
			}
			$this->saveSharedNetworks($newBID, $existingSharedNetworks);
		} else {
			return 0;
		}
	}

	public function addSharedNetwork($bID, $newSharedNetwork)
	{
		if (!is_array($newSharedNetwork)) {
			return false;
		}
		$sharedNetwork = array('bID' => $bID, 'ordinal' => null, 'network' => null, 'title' => null, 'url' => null, 'pin_media' => null, 'description' => null, 'background' => null, 'custom_background' => null, 'icon' => null);
		foreach ($sharedNetwork as $key => $value) {
			if (array_key_exists($key, $newSharedNetwork)) {
				$sharedNetwork[$key] = $newSharedNetwork[$key];
			}
		}

		$res = $this->db->Execute("INSERT INTO " . $this->btNetworksTable . " (bID, ordinal, network, title, url, pin_media, description, background, custom_background, icon) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", $sharedNetwork);
		return $res;
	}

	public function deleteSharedNetworks($bID)
	{
		$res = $this->db->Execute("DELETE FROM " . $this->btNetworksTable . " WHERE bID = ?", array($bID));
		return $res;
	}

	public function getNetworks()
	{
		$db = Loader::db();
		$this->networks = $db->GetArray("SELECT *
			FROM btSkybluesofaSocialNetworks
			WHERE id IN (SELECT MAX(id)
				       FROM btSkybluesofaSocialNetworks
				       GROUP by handle) and css_share=1
			ORDER BY name;");
		return $this->networks;
	}

}
