<?php  

defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

class SkybluesofaSocialShareBlockController
		extends BlockController
{

	var $pobj;
	protected $btTable = 'btSkybluesofaSocialShare';
	protected $btNetworksTable = 'btSkybluesofaSocialSharedNetworks';
	protected $btInterfaceWidth = "580";
	protected $btInterfaceHeight = "450";
	protected $btWrapperClass = 'ccm-ui';
	protected $db = null;
	protected $thumbnail_handle = array('page_thumbnail', 'thumbnail');

	/**
	 * Used for localization. If we want to localize the name/description we have to include this
	 */
	public function getBlockTypeDescription()
	{
		return t("Displays social sharing buttons on your site");
	}

	public function getBlockTypeName()
	{
		return t("Social Share");
	}

	public function __construct($obj = null)
	{
		parent::__construct($obj);
		$this->db = Loader::db();
	}

	public function view()
	{
		$pkg = Loader::package('skybluesofa_social_share');
		echo "<!-- Social Share v" . $pkg->getPackageVersion() . " by Sky Blue Sofa -->";

		if (empty($this->layout))
			$this->layout = 'horizontal';
		$this->set('layout', $this->layout);
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('settings', $this->getShareSettings());
		$this->set('bID', $this->bID);

		$currentPage = Page::getCurrentPage();
		Loader::helper('navigation');

		$this->set('sbsss_cID', $currentPage->getCollectionID());
		$this->set('sbsss_pageURL', NavigationHelper::getLinkToCollection($currentPage, true));
		$this->set('sbsss_pageTitle', $currentPage->getCollectionAttributeValue('meta_title') ? $currentPage->getCollectionAttributeValue('meta_title') : $currentPage->getCollectionName());
		$this->set('sbsss_pageDescription', $currentPage->getCollectionAttributeValue('meta_description') ? str_replace(array("\r\n", "\n", "\r", "  "), " ", $currentPage->getCollectionAttributeValue('meta_description')) : '');
		$this->set('submitBorderColor', str_replace("#", "", $this->alter_brightness($this->record->emailShareSubmitColor, -20)));
		$numberOfEmails = $this->db->GetOne("SELECT count(*) FROM btSkybluesofaSharedEmails WHERE cID=?", array($currentPage->getCollectionID()));
		$this->set('numberOfEmails', $numberOfEmails ? $numberOfEmails : '0');
		$this->set('pinterest_image', $this->getPageThumbnail());
	}

	function add()
	{
		if (empty($this->emailShareBackgroundColor))
			$this->emailShareBackgroundColor = "0A9AB9";
		$this->set('emailShareBackgroundColor', $this->emailShareBackgroundColor);
		if (empty($this->emailShareSubmitColor))
			$this->emailShareSubmitColor = "FFA145";
		$this->set('emailShareSubmitColor', $this->emailShareSubmitColor);
		if (empty($this->floating_offset))
			$this->floating_offset = "0";
		$this->set('floating_offset', $this->floating_offset);
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('pinterest_image', $this->getPageThumbnail());
	}

	function edit()
	{
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('pinterest_image', $this->getPageThumbnail());
	}

	function getPageThumbnail()
	{
		Loader::model('file');
		$currentPage = Page::getCurrentPage();
		foreach ($this->thumbnail_handle as $thumbnail_handle) {
			$thumbnail = $currentPage->getAttribute($thumbnail_handle);
			if (is_object($thumbnail)) {
				$fID = $thumbnail->getFileID();
				$imageUrl = BASE_URL . File::getRelativePathFromID($fID);
				if ($imageUrl)
					return $imageUrl;
			}
		}
		return false;
	}

	function action_shareviaemail()
	{
		$cID = $_REQUEST['cID'];
		$pageURL = $_REQUEST['pageURL'];
		$pageTitle = $_REQUEST['pageTitle'];
		$pageDescription = $_REQUEST['pageDescription'];
		$fromEmailAddress = trim($_REQUEST['emailFrom']);
		$fromName = $fromEmailAddress;
		$toEmailAddress = trim($_REQUEST['emailTo']);
		$toName = $toEmailAddress;
		$comment = trim($_REQUEST['comment']);
		$response = array('success' => 1);

		if (empty($toEmailAddress)) {
			$response['success'] = 0;
			$response['to_email_issue'] = 'empty';
		} elseif (!$this->check_email_address($toEmailAddress)) {
			$response['success'] = 0;
			$response['to_email_issue'] = 'invalid';
		} elseif (empty($fromEmailAddress)) {
			$response['success'] = 0;
			$response['from_email_issue'] = 'empty';
		} elseif (!$this->check_email_address($fromEmailAddress)) {
			$response['success'] = 0;
			$response['from_email_issue'] = 'invalid';
		} elseif (empty($comment)) {
			$response['success'] = 0;
			$response['comment_issue'] = 'empty';
		}

		if ($response['success']) {
			$db = Loader::db();
			$vals = array($toName, $toEmailAddress, $fromName, $fromEmailAddress, $cID, $pageURL, $pageTitle, $comment, date('Y-m-d H:i:s'));
			$db->execute('INSERT INTO btSkybluesofaSharedEmails (toName, toEmail, fromName, fromEmail, cID, url, title, comment, date) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)', $vals);

			$mh = Loader::helper('mail');
			$mh->to($toEmailAddress, $toName);
			$mh->addParameter('comment', $comment);
			$mh->addParameter('url', $pageURL);
			$mh->addParameter('title', stripslashes($pageTitle));
			$mh->addParameter('description', stripslashes($pageDescription));
			$mh->from($fromEmailAddress, $fromName);
			$mh->load('share_page', 'skybluesofa_social_share');
			$mh->setSubject($fromName . t(' has shared this with you: ') . $pageTitle);
			//echo $mh->bodyHTML.'<br>';
			@$mh->sendMail();

			$response['count'] = $db->GetOne("SELECT count(*) FROM btSkybluesofaSharedEmails WHERE cID=?", array($cID));
		}
		
		print Loader::helper('json')->encode($response);
		die();
	}

	private function check_email_address($email)
	{
		// the function 'filter_var' only exists in php 5.2.0+
		if (function_exists('filter_var')) {
			return filter_var($email, FILTER_VALIDATE_EMAIL);
		}

		// Thanks to http://www.linuxjournal.com/article/9585 for the remainder of this functionality
		// First, we check that there's one @ symbol,
		// and that the lengths are right.
		if (!preg_match("/^[^@]{1,64}@[^@]{1,255}$/", $email)) {
			return false;
		}
		// Split it into sections to make life easier
		$email_array = explode("@", $email);
		// Wrong number of parts in the email address
		if (count($email_array) != 2) {
			return false;
		}
		$local_array = explode(".", $email_array[0]);
		for ($i = 0; $i < count($local_array); $i++) {
			if (!preg_match("/^(([A-Za-z0-9!#$%&'*+/=?^_`{|}~-][A-Za-z0-9!#$%&'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$/", $local_array[$i])) {
				return false;
			}
		}
		// Check if domain is IP. If not, 
		// it should be valid domain name
		if (preg_match("/^\[?[0-9\.]+\]?$/", $email_array[1])) {
			return false;
		}
		// Check the domain name
		$domain_array = explode(".", $email_array[1]);
		if (count($domain_array) < 2) {
			return false; // Not enough parts to domain
		}
		for ($i = 0; $i < count($domain_array); $i++) {
			if (!preg_match("/^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$/", $domain_array[$i])) {
				return false;
			}
		}
		return true;
	}

	/*
	 * save block config
	 */

	public function save($args)
	{
		$args['emailShareBackgroundColor'] = empty($args['emailShareBackgroundColor']) ? '0A9AB9' : $args['emailShareBackgroundColor'];
		$args['emailShareSubmitColor'] = empty($args['emailShareSubmitColor']) ? 'ffa145' : $args['emailShareSubmitColor'];
		$args['floating_offset'] = empty($args['floating_offset']) ? '0' : $args['floating_offset'];
		parent::save($args);
		$this->saveSharedNetworks($this->bID, $args);
	}

	function duplicate($newBID)
	{
		parent::duplicate($newBID);
		$this->duplicateSharedNetworks($newBID);
	}

	public function getSharedNetworks($bID)
	{
		$po = $this->db->GetArray("SELECT * FROM " . $this->btNetworksTable . " WHERE ordinal IS NOT NULL AND bID = ? ORDER BY ordinal", array($bID));
		$no = $this->db->GetArray("SELECT * FROM " . $this->btNetworksTable . " WHERE ordinal IS NULL AND bID = ? ORDER BY connID", array($bID));
		$res = array_merge($po, $no);
		/* We're not going to fill in this stuff anymore
		  foreach ($res as $key=>$sharedNetwork) {
		  $currentPage = Page::getCurrentPage();
		  if (empty($sharedNetwork['url'])) {
		  Loader::helper('navigation');
		  $res[$key]['url'] = NavigationHelper::getLinkToCollection($currentPage, true);
		  }
		  if (empty($sharedNetwork['dg_description'])) {
		  $res[$key]['dg_description'] = $currentPage->getCollectionDescription();
		  }
		  }
		 */
		return $res;
	}

	public function getShareSettings()
	{
		$s = $this->db->GetArray("SELECT * FROM aoSkybluesofaSocialShareSettings");
		$settings = array();
		foreach ($s as $setting) {
			if ($setting['handle'] == 'facebook_app_id' && !$setting['value']) {
				$siteFbAppId = $this->db->GetCol('SELECT value FROM btSkybluesofaSocialPostSettings WHERE group_name=? AND handle=?', array('facebook', 'app_id'));
				if ($siteFbAppId[0]) {
					$setting['value'] = $siteFbAppId[0];
				} else {
					$setting['value'] = '187816978006139';
				}
			}
			$settings[$setting['handle']] = $setting['value'];
		}
		return $settings;
	}

	public function saveSharedNetworks($bID, $args)
	{
		if (!isset($args['sharedNetworks']) || !is_array($args['sharedNetworks'])) {
			return false;
		}
		$this->deleteSharedNetworks($bID);
		$ordinal = 1;

		$networkHandles = array();
		foreach ($this->getNetworks() as $network) {
			if ($network['active']) {
				$networkHandles[] = $network['handle'];
			}
		}
		foreach ($args['sharedNetworks']['network'] as $key => $value) {
			if ($key && !empty($args['sharedNetworks']['network'][$key])) {
				if (in_array($args['sharedNetworks']['network'][$key], $networkHandles)) {
					$sharedNetwork['bID'] = $bID;
					$sharedNetwork['ordinal'] = $ordinal;
					$sharedNetwork['network'] = $args['sharedNetworks']['network'][$key];
					$sharedNetwork['title'] = $args['sharedNetworks']['title'][$key];
					$sharedNetwork['url'] = $args['sharedNetworks']['url'][$key];
					$sharedNetwork['tw_recommend'] = $args['sharedNetworks']['tw_recommend'][$key];
					$sharedNetwork['fb_verb'] = $args['sharedNetworks']['fb_verb'][$key];
					$sharedNetwork['dg_topic'] = $args['sharedNetworks']['dg_topic'][$key];
					$sharedNetwork['dg_description'] = $args['sharedNetworks']['dg_description'][$key];
					$sharedNetwork['pin_media'] = $args['sharedNetworks']['pin_media'][$key];
					$this->addSharedNetwork($bID, $sharedNetwork);
					$ordinal++;
				}
			}
		}
	}

	function duplicateSharedNetworks($newBID)
	{
		$b = $this->getBlockObject();
		$c = $b->getBlockCollectionObject();

		$res = $this->db->query("select * from " . $this->btTable . " where bID = ?", array($this->bID));
		$existingBlock = $res->fetchRow();

		if (count($existingBlock) > 0) {
			$oldBID = $existingBlock['bID'];

			$res = $this->db->GetArray("SELECT * FROM " . $this->btNetworksTable . " WHERE bID=?", array($this->bID));
			$existingSharedNetworks = array('sharedNetworks' => array());
			$existingSharedNetworks['sharedNetworks']['network'][] = null;
			$existingSharedNetworks['sharedNetworks']['title'][] = null;
			$existingSharedNetworks['sharedNetworks']['url'][] = null;
			$existingSharedNetworks['sharedNetworks']['tw_recommend'][] = null;
			$existingSharedNetworks['sharedNetworks']['fb_verb'][] = null;
			$existingSharedNetworks['sharedNetworks']['dg_topic'][] = null;
			$existingSharedNetworks['sharedNetworks']['pin_media'][] = null;
			$existingSharedNetworks['sharedNetworks']['dg_description'][] = null;
			foreach ($res as $key => $sharedNetwork) {
				$existingSharedNetworks['sharedNetworks']['network'][] = $sharedNetwork['network'];
				$existingSharedNetworks['sharedNetworks']['title'][] = $sharedNetwork['title'];
				$existingSharedNetworks['sharedNetworks']['url'][] = $sharedNetwork['url'];
				$existingSharedNetworks['sharedNetworks']['tw_recommend'][] = $sharedNetwork['tw_recommend'];
				$existingSharedNetworks['sharedNetworks']['fb_verb'][] = $sharedNetwork['fb_verb'];
				$existingSharedNetworks['sharedNetworks']['dg_topic'][] = $sharedNetwork['dg_topic'];
				$existingSharedNetworks['sharedNetworks']['pin_media'][] = $sharedNetwork['pin_media'];
				$existingSharedNetworks['sharedNetworks']['dg_description'][] = $sharedNetwork['dg_description'];
			}
			$this->saveSharedNetworks($newBID, $existingSharedNetworks);
		} else {
			return 0;
		}
	}

	public function addSharedNetwork($bID, $newSharedNetwork)
	{
		if (!is_array($newSharedNetwork)) {
			return false;
		}
		$sharedNetwork = array('bID' => $bID, 'ordinal' => null, 'network' => null, 'title' => null, 'url' => null, 'tw_recommend' => null, 'fb_verb' => null, 'dg_topic' => null, 'pin_media' => null, 'dg_description' => null);
		foreach ($sharedNetwork as $key => $value) {
			if (array_key_exists($key, $newSharedNetwork)) {
				$sharedNetwork[$key] = $newSharedNetwork[$key];
			}
		}

		$res = $this->db->Execute("INSERT INTO " . $this->btNetworksTable . " (bID, ordinal, network, title, url, tw_recommend, fb_verb, dg_topic, pin_media, dg_description) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", $sharedNetwork);
		return $res;
	}

	public function deleteSharedNetworks($bID)
	{
		$res = $this->db->Execute("DELETE FROM " . $this->btNetworksTable . " WHERE bID = ?", array($bID));
		return $res;
	}

	public function getNetworks()
	{
		$db = Loader::db();
		$this->networks = $db->GetArray("SELECT *
			FROM btSkybluesofaSocialNetworks
			WHERE id IN (SELECT MAX(id)
				       FROM btSkybluesofaSocialNetworks
				       GROUP by handle) AND share=1
			ORDER BY name;");
		return $this->networks;
	}

	function alter_brightness($colourstr, $steps)
	{
		$colourstr = str_replace('#', '', $colourstr);
		$rhex = substr($colourstr, 0, 2);
		$ghex = substr($colourstr, 2, 2);
		$bhex = substr($colourstr, 4, 2);

		$r = hexdec($rhex);
		$g = hexdec($ghex);
		$b = hexdec($bhex);

		$r = max(0, min(255, $r + $steps));
		$g = max(0, min(255, $g + $steps));
		$b = max(0, min(255, $b + $steps));

		return '#' . dechex($r) . dechex($g) . dechex($b);
	}

}
