<?php  

defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

class DashboardBlocksSocialShareController
		extends Controller
{

	var $helpers = array('form');

	public function on_start()
	{
		$this->token = Loader::helper('validation/token');
	}

	public function update()
	{
		if ($this->token->validate("update_share_settings")) {
			if ($this->isPost()) {
				if (isset($_POST['setting'])) {
					$db = Loader::db();

					foreach ($_POST['setting'] as $handle => $value) {
						$db->execute('UPDATE aoSkybluesofaSocialShareSettings SET `value`=? WHERE handle=?', array($value, $handle));
					}
					$this->redirect("/dashboard/blocks/social_share", "updated");
					die();
				}
			}
		}
	}

	public function updated()
	{
		$this->set('message', 'Settings for Socializer Share block have been updated.');
		$this->loadMeta();
	}

	public function view()
	{
		$this->loadMeta();
	}

	public function loadMeta()
	{
		$db = Loader::db();

		$settings = $db->GetArray("SELECT * FROM aoSkybluesofaSocialShareSettings ORDER BY name");
		$this->set('settings', $settings);
	}

}
