<?php  

defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

Loader::controller('/profile/edit');

class ProfilePagePromotionController
		extends ProfileEditController
{

	public function __construct()
	{
		parent::__construct();
		$this->html = Loader::helper('html');
		$this->user = new User();
	}

	public function save()
	{
		foreach (array('facebook', 'twitter', 'linkedin') as $network) {
			$prefixes = new stdClass();
			if ($_REQUEST[$network]['prefix']) {
				foreach ($_REQUEST[$network]['prefix'] as $key => $value) {
					$prefixes->$key = $value;
				}
			}
			$_REQUEST[$network]['prefix'] = Loader::helper('json')->encode($prefixes);
		}

		Loader::model('user/social_post', 'skybluesofa_social_share');
		$socialPost = new UserSocialPost();
		if ($_REQUEST['twitter']) {
			$socialPost->twitter->saveSetting('use', isset($_REQUEST['twitter']['use']) ? 1 : 0);
			$socialPost->twitter->saveSetting('prefix', $_REQUEST['twitter']['prefix']);
			$socialPost->twitter->saveSetting('use_hashtags', isset($_REQUEST['twitter']['use_hashtags']) ? 1 : 0);
			$socialPost->twitter->saveSetting('send_post', isset($_REQUEST['twitter']['send_post']) ? 1 : 0);
			$socialPost->twitter->saveSetting('allow_promotion', isset($_REQUEST['twitter']['allow_promotion']) ? 1 : 0);
			$socialPost->twitter->saveSetting('promote_default', isset($_REQUEST['twitter']['promote_default']) ? 1 : 0);
			$socialPost->twitter->saveSetting('promote_prefix', $_REQUEST['twitter']['promote_prefix']);
			$socialPost->twitter->saveSetting('use_hashtags_promote_default', isset($_REQUEST['twitter']['use_hashtags_promote_default']) ? 1 : 0);
		}

		if ($_REQUEST['facebook']) {
			$socialPost->facebook->saveSetting('use', isset($_REQUEST['facebook']['use']) ? 1 : 0);
			if (isset($_REQUEST['facebook']['app_id'])) {
				$socialPost->facebook->saveSetting('app_id', $_REQUEST['facebook']['app_id']);
				$socialPost->facebook->saveSetting('app_secret', $_REQUEST['facebook']['app_secret']);
			} else {
				$socialPost->facebook->removeCredentials();
			}
			$socialPost->facebook->saveSetting('prefix', $_REQUEST['facebook']['prefix']);
			$socialPost->facebook->saveSetting('use_hashtags', isset($_REQUEST['facebook']['use_hashtags']) ? 1 : 0);
			$socialPost->facebook->saveSetting('post_to_page', $_REQUEST['facebook']['post_to_page']);
			if (isset($_REQUEST['facebook']['post_to_page']) && !isset($_REQUEST['facebook']['post_to_page_name'])) {
				$socialPost->facebook->saveSetting('post_to_page_name', $socialPost->facebook->getTimelineById($_REQUEST['facebook']['post_to_page']));
			}
			$socialPost->facebook->saveSetting('send_post', isset($_REQUEST['facebook']['send_post']) ? 1 : 0);
			$socialPost->facebook->saveSetting('allow_promotion', isset($_REQUEST['facebook']['allow_promotion']) ? 1 : 0);
			$socialPost->facebook->saveSetting('promote_default', isset($_REQUEST['facebook']['promote_default']) ? 1 : 0);
			$socialPost->facebook->saveSetting('promote_prefix', $_REQUEST['facebook']['promote_prefix']);
			$socialPost->facebook->saveSetting('use_hashtags_promote_default', isset($_REQUEST['facebook']['use_hashtags_promote_default']) ? 1 : 0);
		}

		if ($_REQUEST['linkedin']) {
			$socialPost->linkedin->saveSetting('use', isset($_REQUEST['linkedin']['use']) ? 1 : 0);
			if (isset($_REQUEST['linkedin']['api_key'])) {
				$socialPost->linkedin->saveSetting('api_key', $_REQUEST['linkedin']['api_key']);
				$socialPost->linkedin->saveSetting('api_secret', $_REQUEST['linkedin']['api_secret']);
				$socialPost->linkedin->saveSetting('oauth_token', $_REQUEST['linkedin']['oauth_token']);
				$socialPost->linkedin->saveSetting('oauth_secret', $_REQUEST['linkedin']['oauth_secret']);
			} else {
				$socialPost->linkedin->removeCredentials();
			}
			$socialPost->linkedin->saveSetting('prefix', $_REQUEST['linkedin']['prefix']);
			$socialPost->linkedin->saveSetting('post_to_page', $_REQUEST['linkedin']['post_to_page']);
			$socialPost->linkedin->saveSetting('send_post', isset($_REQUEST['linkedin']['send_post']) ? 1 : 0);
			$socialPost->linkedin->saveSetting('allow_promotion', isset($_REQUEST['linkedin']['allow_promotion']) ? 1 : 0);
			$socialPost->linkedin->saveSetting('promote_default', isset($_REQUEST['linkedin']['promote_default']) ? 1 : 0);
			$socialPost->linkedin->saveSetting('promote_prefix', $_REQUEST['linkedin']['promote_prefix']);
		}

		$this->redirect("/profile/page_promotion", 'saved');
	}

	public function saved()
	{
		$this->set('message', 'Page promotion settings have been successfully saved.');
		$this->addAssets();
		$this->getViewInfo();
	}

	public function tw()
	{
		Loader::model('user/social_post', 'skybluesofa_social_share');
		$socialPost = new UserSocialPost($this->user);
		if (strlen($_REQUEST['oauth_token']) > 0) {
			if ($socialPost->twitter->saveCredentials()) {
				$this->set('message', 'You have successfully connected with Twitter.');
			} else {
				$this->set('error', 'There was an issue when attempting to connect with Twitter.');
			}
		} else {
			$socialPost->twitter->isRevoked();
		}
		$this->redirect('/profile/page_promotion');
		die();
	}

	public function fb()
	{
		Loader::model('user/social_post', 'skybluesofa_social_share');
		$socialPost = new UserSocialPost($this->user);
		if ((strlen($_REQUEST['state']) > 0) && (strlen($_REQUEST['code']) > 0)) {
			if ($socialPost->facebook->saveCredentials()) {
				$this->set('message', 'You have successfully connected with Facebook.');
			} else {
				$this->set('error', 'There was an issue when attempting to connect with Facebook.');
			}
		} else {
			$socialPost->facebook->isRevoked();
		}
		//$this->redirect('/profile/page_promotion');
		//die();
	}

	public function li()
	{
		Loader::model('user/social_post', 'skybluesofa_social_share');
		$socialPost = new UserSocialPost($this->user);
		if (strlen($_REQUEST['oauth_token']) > 0) {
			if ($socialPost->linkedin->saveCredentials()) {
				$this->set('message', 'You have successfully connected with LinkedIn.');
			} else {
				$this->set('error', 'There was an issue when attempting to connect with LinkedIn.');
			}
		} else {
			$socialPost->linkedin->isRevoked();
		}
		$this->redirect('/profile/page_promotion');
		die();
	}

	private function getViewInfo()
	{
		Loader::model('user/social_post', 'skybluesofa_social_share');
		Loader::model('site/social_post', 'skybluesofa_social_share');
		$userSocialPost = new UserSocialPost($this->user);
		$userSocialPost->twitter->isRevoked();
		$userSocialPost->facebook->isRevoked();
		$userSocialPost->linkedin->isRevoked();

		$this->set('socialPost', $userSocialPost);

		$siteSocialPost = new SiteSocialPost();
		$this->set('siteSocialPost', $siteSocialPost);
		$this->setComposerPageTypes();
	}

	public function remove_twitter_authorization()
	{
		Loader::model('user/social_post', 'skybluesofa_social_share');
		$socialPost = new UserSocialPost();
		$socialPost->twitter->updateTwitterCredentials(null, null);
		$this->set('message', 'Posts to Twitter have been deactivated for you.');
		$this->addAssets();
	}

	private function setComposerPageTypes()
	{
		Loader::model('collection_types');
		if (method_exists('CollectionType', 'getComposerPageTypes')) {
			$composerPageTypes = CollectionType::getComposerPageTypes();
		} else {
			$composerPageTypes = array();
		}
		$this->set('composerPageTypes', $composerPageTypes);
	}

	function addAssets()
	{
		$this->addHeaderItem($this->html->css('/profile/page_promotion.css', 'skybluesofa_social_share'));
		$this->addHeaderItem('<link href="//netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css" rel="stylesheet">');
		$this->addFooterItem($this->html->javascript('/profile/page_promotion.js', 'skybluesofa_social_share'));
	}

	function view()
	{
		$this->getViewInfo();
		$this->addAssets();
	}

}
