<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

?>
<div class="clearfix">
	<label class="checkbox" id="use_on_facebook" style="text-align:left;width:auto;">
		<input type="checkbox" name="facebook[use]" value="1" <?php   if ($socialPost->facebook->settings['use']['value'] == 1) { ?> checked <?php   } ?> />
		<?php   echo t('Allow posting to Facebook') ?>
	</label>
</div>

<div id="use_on_facebook_div" style="<?php   if ($socialPost->facebook->settings['use']['value'] != 1) { ?>display:none;<?php   } ?>">
	<h3><?php   echo t('Users'); ?></h3>
	<div class="clearfix">
		<label class="checkbox" style="width:auto;text-align:left;" id="twitter_allow_author_send_post">
			<input type="checkbox" name="facebook[allow_author_send_post]" value="1" <?php   if ($socialPost->facebook->settings['allow_author_send_post']['value'] == 1) { ?> checked <?php   } ?> />
			<?php   echo t('Allow authors to post to a Facebook timeline of their choosing when they add a new composer page. (Profiles must be enabled.)') ?>
		</label>
	</div>
	<h3>Site</h3>
	<?php   if (!$socialPost->facebook->settings['app_id']['value'] || !$socialPost->facebook->settings['app_secret']['value']) { ?>
		<div class="clearfix alert-message danger">
			<p><?php   echo t("You haven't entered an AppID and App Secret."); ?></p>
			<p><?php   echo t('You can create a Facebook App at <a href="https://developers.facebook.com/apps" target="_blank">Facebook Apps</a>.'); ?></p>
		</div>
	<?php   } ?>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="Application ID" >
			<input type="text" name="facebook[app_id]" value="<?php   echo $socialPost->facebook->settings['app_id']['value']; ?>" style="width:225px;"><span class="add-on"><?php   echo t('AppID'); ?></span>
		</div>
	</div>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="Application Secret" >
			<input type="text" name="facebook[app_secret]" value="<?php   echo $socialPost->facebook->settings['app_secret']['value']; ?>" style="width:195px;"><span class="add-on"><?php   echo t('App Secret'); ?></span>
		</div>
	</div>

	<?php   if ($socialPost->facebook->settings['app_id']['value'] && $socialPost->facebook->settings['app_secret']['value']) { ?>
		<?php   if (!$socialPost->facebook->settings['oauth_token']['value']) { ?>
			<div class="clearfix alert-message danger">
				<p><?php   echo t('You are not connected with Facebook.'); ?></p>
				<p><?php   echo t('Please make sure that you are currently logged in with the Facebook account that you would like to connect to this site.'); ?></p>
				<p>
					<input type="button" class="btn ccm-button-v2 primary" value="Authorize with Facebook" onclick="location.href = '<?php   echo $socialPost->facebook->getAuthorizeUrl(); ?>';">
				</p>
			</div>
			<?php  
		} elseif (!$socialPost->facebook->getTimeline()) {
			$pages = $socialPost->facebook->getUserTimelines();
            ?>
			<div class="clearfix alert-message dancer">
				<p><?php   echo t('You are currently connected with Facebook, but do not have a timeline selected. Please choose a timeline:'); ?></p>
                <select name="facebook[post_to_page]">
                    <option value=""></option>
                    <option value="<?php   echo $socialPost->facebook->user; ?>" <?php   echo $timeline['id']==$socialPost->facebook->user ? 'selected="selected"' : ''; ?>><?php   echo t('My Timeline'); ?></option>
                    <?php  
                    if (is_array($pages) && count($pages)>0) :
                        foreach ($pages as $page) :
                            ?>
                            <option value="<?php   echo $page['id']; ?>"<?php   echo $timeline['id']==$page['id'] ? 'selected="selected"' : ''; ?>><?php   echo $page['name']; ?></option>
                        <?php  
                        endforeach;
                    endif;
                    ?>
                </select>
				<ol>
					<li><?php   echo t('Choose a timeline above'); ?></li>
					<li><?php   echo t("Click the 'Update Social Network Settings' button below."); ?></li>
				</ol>
			</div>

			<?php  
		} else {
			$timeline = $socialPost->facebook->getTimeline();
            $pages = $socialPost->facebook->getUserTimelines();
			?>
			<div class="clearfix alert-message info">
				<p><?php   echo t('You are currently connected with Facebook and posting to:'); ?></p>
                <select name="facebook[post_to_page]">
                    <option value=""></option>
                    <option value="<?php   echo $socialPost->facebook->user; ?>" <?php   echo $timeline['id']==$socialPost->facebook->user ? 'selected="selected"' : ''; ?>><?php   echo t('My Timeline'); ?></option>
                    <?php  
                    if (is_array($pages) && count($pages)>0) :
                        foreach ($pages as $page) :
                            ?>
                            <option value="<?php   echo $page['id']; ?>"<?php   echo $timeline['id']==$page['id'] ? 'selected="selected"' : ''; ?>><?php   echo $page['name']; ?></option>
                        <?php  
                        endforeach;
                    endif;
                    ?>
                </select>
				<p id="removeAuthorization" style="margin-top:7px;cursor:pointer;text-decoration:underline;"><?php   echo t('Remove authorization'); ?></p>
				<div id="removeAuthorizationInstructions" style="display:none;">
					<ol>
                        <?php   echo t('%1$s <a href="https://www.facebook.com/settings?tab=applications" target="_blank">%2$s</a>.', "Click the 'Remove' icon on your", 'Facebook Apps Settings page'); ?>
						<li><?php   echo t("Click the 'Update Social Network Settings' button below."); ?></li>
					</ol>
				</div>
			</div>
			<?php   if (version_compare(APP_VERSION, '5.5.0', '>=')) { ?>
				<div class="clearfix">
					<label class="checkbox" style="width:auto;text-align:left;" id="facebook_send_post">
						<input type="checkbox" name="facebook[send_post]" value="1" <?php   if ($socialPost->facebook->settings['send_post']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('Post to Facebook when a new composer page is added') ?>
					</label>
				</div>
				<div id="send_post_on_facebook_div" style="margin-left:21px;<?php   if ($socialPost->facebook->settings['send_post']['value'] != 1) { ?>display:none;<?php   } ?>">
					<?php 
                    $facebookPrefixes = $socialPost->facebook->settings['prefix']['value'];
                    if (!is_object($facebookPrefixes)) {
                        $facebookPrefixes = Loader::helper('json')->decode($facebookPrefixes);
                    }
                    ?>
					<table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
						<thead>
							<tr>
								<th><?php   echo t('Page Type'); ?></th>
								<th><?php   echo t('Intro Text'); ?></th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><i>Default</i></td>
								<td><input type="text" name="facebook[prefix][0]" value="<?php  
									$index = 0;
									$defaultfacebookPrefix = $facebookPrefixes->$index;
									echo $defaultfacebookPrefix;
									?>"></td>
							</tr>
							<?php  
							foreach ($composerPageTypes as $cpt) {
								$index = $cpt->ctID;
								$value = (isset($facebookPrefixes->$index)) ? $facebookPrefixes->$index : $defaultfacebookPrefix;
								?>
								<tr>
									<td><?php   echo $cpt->ctName; ?></td>
									<td><input type="text" name="facebook[prefix][<?php   echo $index; ?>]" value="<?php   echo $value; ?>"></td>
								</tr>
							<?php   } ?>
						</tbody>
					</table>
					<div class="clearfix">
						<label class="checkbox" style="margin-left:0;width:auto;text-align:left;">
							<input type="checkbox" name="facebook[use_hashtags]" value="1" <?php   if ($socialPost->facebook->settings['use_hashtags']['value'] == 1) { ?> checked <?php   } ?> />
							<?php   echo t('Add Hashtags at the end of the post using the page tags attribute') ?>
						</label>
					</div>
				</div>
				<div class="clearfix">
					<label class="checkbox" style="width:auto;text-align:left;" id="facebook_allow_author_send_post">
						<input type="checkbox" name="facebook[allow_author_send_post]" value="1" <?php   if ($socialPost->facebook->settings['allow_author_send_post']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('Allow authors to post to a Facebook timeline of their choosing when they add a new composer page') ?>
					</label>
				</div>
			<?php   } ?>
			<div class="clearfix" style="padding-bottom:0;"><hr></div>
			<div class="clearfix">
				<label class="checkbox" style="width:auto;text-align:left;" id="facebook_promote">
					<input type="checkbox" name="facebook[allow_promotion]" value="1" <?php   if ($socialPost->facebook->settings['allow_promotion']['value'] == 1) { ?> checked <?php   } ?> />
					<?php   echo t('Allow page editors to promote pages via facebook') ?>
				</label>
			</div>
			<div id="promote_on_facebook_div" style="margin-left:21px;<?php   if ($socialPost->facebook->settings['allow_promotion']['value'] != 1) { ?>display:none;<?php   } ?>">
				<table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
					<thead>
						<tr>
							<th><?php   echo t('Intro Text'); ?></th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><input type="text" name="facebook[promote_prefix]" value="<?php   echo $socialPost->facebook->settings['promote_prefix']['value']; ?>"></td>
						</tr>
					</tbody>
				</table>
				<div class="clearfix">
					<label class="checkbox" style="margin-left:0;width:auto;text-align:left;">
						<input type="checkbox" name="facebook[promote_default]" value="1" <?php   if ($socialPost->facebook->settings['promote_default']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('By default, check the box for promoting pages via facebook') ?>
					</label>
				</div>
				<div class="clearfix">
					<label class="checkbox" style="margin-left:0;width:auto;text-align:left;">
						<input type="checkbox" name="facebook[use_hashtags_promote_default]" value="1" <?php   if ($socialPost->facebook->settings['use_hashtags_promote_default']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('By default, check the box for adding hashtags to the post') ?>
					</label>
				</div>
			</div>
			<?php  
		}
	}
	?> 
</div>
<script>
	$(function() {
		$('#use_on_facebook').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#use_on_facebook_div').slideDown();
			} else {
				$('#use_on_facebook_div').slideUp();
			}
		});
		$('#facebook_post_to_page').bind('change', function() {
			if ($(this).val() != '') {
				$('#facebook_post_settings_div').slideDown();
			} else {
				$('#facebook_post_settings_div').slideUp();
			}
		});
		$('#facebook_send_post').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#send_post_on_facebook_div').slideDown();
			} else {
				$('#send_post_on_facebook_div').slideUp();
			}
		});
		$('#facebook_promote').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#promote_on_facebook_div').slideDown();
			} else {
				$('#promote_on_facebook_div').slideUp();
			}
		});
		$('#chooseTimeline').bind('click', function() {
			$('#use_on_facebook_div #chooseTimelineInstructions').slideToggle();
		});
		$('#removeAuthorization').bind('click', function() {
			$('#use_on_facebook_div #removeAuthorizationInstructions').slideToggle();
		});
	});
</script>