<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */
?> 
<div class="clearfix">
	<label class="checkbox" id="use_on_linkedin" style="text-align:left;width:auto;">
		<input type="checkbox" name="linkedin[use]" value="1" <?php   if ($socialPost->linkedin->settings['use']['value'] == 1) { ?> checked <?php   } ?> />
		<?php   echo t('Allow posting to LinkedIn') ?>
	</label>
</div>

<div id="use_on_linkedin_div" style="<?php   if ($socialPost->linkedin->settings['use']['value'] != 1) { ?>display:none;<?php   } ?>">
	<h3>Users</h3>
	<div class="clearfix">
		<label class="checkbox" style="width:auto;text-align:left;" id="twitter_allow_author_send_post">
			<input type="checkbox" name="linkedin[allow_author_send_post]" value="1" <?php   if ($socialPost->linkedin->settings['allow_author_send_post']['value'] == 1) { ?> checked <?php   } ?> />
			<?php   echo t('Allow authors to post to a LinkedIn feed of their choosing when they add a new composer page. (Profiles must be enabled.)') ?>
		</label>
	</div>
	<h3>Site</h3>
	<?php   if (!$socialPost->linkedin->settings['api_key']['value'] || !$socialPost->linkedin->settings['api_secret']['value']) { ?>
		<div class="clearfix alert-message danger">
			<p><?php   echo t("You haven't entered an API Key and Secret Key."); ?></p>
			<p><a href="https://www.linkedin.com/secure/developer" target="_blank"><?php   echo t("You can create a LinkedIn App at LinkedIn Developer Network"); ?></a>.</p>
			<p><?php   echo t("Make sure you tick the checkboxes for these permissions:"); ?></p>
			<ul>
				<li>r_basicprofile</li>
				<li>r_fullprofile</li>
			</ul>
		</div>
	<?php   } ?>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="API Key" >
			<input type="text" name="linkedin[api_key]" value="<?php   echo $socialPost->linkedin->settings['api_key']['value']; ?>" style="width:225px;"><span class="add-on"><?php   echo t("API Key"); ?></span>
		</div>
	</div>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="API Secret" >
			<input type="text" name="linkedin[api_secret]" value="<?php   echo $socialPost->linkedin->settings['api_secret']['value']; ?>" style="width:205px;"><span class="add-on"><?php   echo t("Secret Key"); ?></span>
		</div>
	</div>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="OAuth User Token" >
			<input type="text" name="linkedin[oauth_token]" value="<?php   echo $socialPost->linkedin->settings['oauth_token']['value']; ?>" style="width:195px;"><span class="add-on"><?php   echo t("OAuth Token"); ?></span>
		</div>
	</div>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="OAuth User Secret" >
			<input type="text" name="linkedin[oauth_secret]" value="<?php   echo $socialPost->linkedin->settings['oauth_secret']['value']; ?>" style="width:193px;"><span class="add-on"><?php   echo t("OAuth Secret"); ?></span>
		</div>
	</div>

	<?php  
	if ($socialPost->linkedin->settings['api_key']['value'] && $socialPost->linkedin->settings['api_secret']['value']
			&& $socialPost->linkedin->settings['oauth_token']['value'] && $socialPost->linkedin->settings['oauth_secret']['value']) {
		?>
		<?php   if (!$socialPost->linkedin->settings['oauth_token']['value']) { ?>
			<div class="clearfix alert-message danger">
				<p><?php   echo t("You are not connected with LinkedIn."); ?></p>
				<p><?php   echo t("Please make sure that you are currently logged in with the LinkedIn account that you would like to connect to this site."); ?></p>
				<p>
					<input type="button" class="btn ccm-button-v2 primary" value="Authorize with LinkedIn" onclick="location.href = '<?php   echo $socialPost->linkedin->getAuthorizeUrl(); ?>';">
				</p>
			</div>
		<?php   } else { ?>
			<div class="clearfix alert-message info">
				<p><?php   echo t("You are currently connected with LinkedIn."); ?></p>
                <p><?php   echo t('%1$s <a href="https://www.linkedin.com/secure/developer" target="_blank">%2$s</a>.', "To remove authorization, click the 'Revoke' button for your application on your", 'LinkedIn Applications page'); ?></p>
			</div>
			<?php   if (version_compare(APP_VERSION, '5.5.0', '>=')) { ?>
				<div class="clearfix">
					<label class="checkbox" style="width:auto;text-align:left;" id="linkedin_send_post">
						<input type="checkbox" name="linkedin[send_post]" value="1" <?php   if ($socialPost->linkedin->settings['send_post']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('Post to LinkedIn when a new composer page is added') ?>
					</label>
				</div>
				<div id="send_post_on_linkedin_div" style="margin-left:21px;<?php   if ($socialPost->linkedin->settings['send_post']['value'] != 1) { ?>display:none;<?php   } ?>">
                    <?php 
                    $linkedinPrefixes = $socialPost->linkedin->settings['prefix']['value'];
                    if (!is_object($linkedinPrefixes)) {
                        $linkedinPrefixes = Loader::helper('json')->decode($linkedinPrefixes);
                    }
                    ?>

                    <table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
						<thead>
							<tr>
								<th><?php   echo t("Page Type"); ?></th>
								<th><?php   echo t("Intro Text"); ?></th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><i><?php   echo t("Default"); ?></i></td>
								<td><input type="text" name="linkedin[prefix][0]" value="<?php  
									$index = 0;
									$defaultlinkedinPrefix = $linkedinPrefixes->$index;
									echo $defaultlinkedinPrefix;
									?>"></td>
							</tr>
							<?php  
							foreach ($composerPageTypes as $cpt) {
								$index = $cpt->ctID;
								$value = (isset($linkedinPrefixes->$index)) ? $linkedinPrefixes->$index : $defaultlinkedinPrefix;
								?>
								<tr>
									<td><?php   echo $cpt->ctName; ?></td>
									<td><input type="text" name="linkedin[prefix][<?php   echo $index; ?>]" value="<?php   echo $value; ?>"></td>
								</tr>
							<?php   } ?>
						</tbody>
					</table>
				</div>
				<div class="clearfix">
					<label class="checkbox" style="width:auto;text-align:left;" id="linkedin_allow_author_send_post">
						<input type="checkbox" name="linkedin[allow_author_send_post]" value="1" <?php   if ($socialPost->linkedin->settings['allow_author_send_post']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('Allow authors to post to a LinkedIn account when they add a new composer page'); ?>
					</label>
				</div>
			<?php   } ?>
			<div class="clearfix" style="padding-bottom:0;"><hr></div>
			<div class="clearfix">
				<label class="checkbox" style="width:auto;text-align:left;" id="linkedin_promote">
					<input type="checkbox" name="linkedin[allow_promotion]" value="1" <?php   if ($socialPost->linkedin->settings['allow_promotion']['value'] == 1) { ?> checked <?php   } ?> />
					<?php   echo t('Allow page editors to promote pages via LinkedIn') ?>
				</label>
			</div>
			<div id="promote_on_linkedin_div" style="margin-left:21px;<?php   if ($socialPost->linkedin->settings['allow_promotion']['value'] != 1) { ?>display:none;<?php   } ?>">
				<table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
					<thead>
						<tr>
							<th><?php   echo t("Intro Text"); ?></th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><input type="text" name="linkedin[promote_prefix]" value="<?php   echo $socialPost->linkedin->settings['promote_prefix']['value']; ?>"></td>
						</tr>
					</tbody>
				</table>
				<div class="clearfix">
					<label class="checkbox" style="margin-left:0;width:auto;text-align:left;">
						<input type="checkbox" name="linkedin[promote_default]" value="1" <?php   if ($socialPost->linkedin->settings['promote_default']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('By default, check the box for promoting pages via linkedin') ?>
					</label>
				</div>
			</div>
			<?php  
		}
	}
	?> 
</div>
<script>
	$(function() {
		$('#use_on_linkedin').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#use_on_linkedin_div').slideDown();
			} else {
				$('#use_on_linkedin_div').slideUp();
			}
		});
		$('#linkedin_post_to_page').bind('change', function() {
			if ($(this).val() != '') {
				$('#linkedin_post_settings_div').slideDown();
			} else {
				$('#linkedin_post_settings_div').slideUp();
			}
		});
		$('#linkedin_send_post').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#send_post_on_linkedin_div').slideDown();
			} else {
				$('#send_post_on_linkedin_div').slideUp();
			}
		});
		$('#linkedin_promote').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#promote_on_linkedin_div').slideDown();
			} else {
				$('#promote_on_linkedin_div').slideUp();
			}
		});
	});
</script>