<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */
?> 
<div class="clearfix">
	<label class="checkbox" id="sbs_sp_twitter_use" style="text-align:left;">
		<input type="checkbox" name="twitter[use]" value="1" <?php   if ($socialPost->twitter->settings['use']['value'] == 1) { ?> checked <?php   } ?> />
		<?php   echo t('Allow posting to Twitter') ?>
	</label>
</div>
<div id="use_on_twitter_div" style="<?php   if ($socialPost->twitter->settings['use']['value'] != 1) { ?>display:none;<?php   } ?>">
	<h3>Users</h3>
	<div class="clearfix">
		<label class="checkbox" style="width:auto;text-align:left;" id="twitter_allow_author_send_post">
			<input type="checkbox" name="twitter[allow_author_send_post]" value="1" <?php   if ($socialPost->twitter->settings['allow_author_send_post']['value'] == 1) { ?> checked <?php   } ?> />
			<?php   echo t('Allow authors to post to a Twitter feed of their choosing when they add a new composer page. (Profiles must be enabled.)') ?>
		</label>
	</div>
	<h3>Site</h3>
	<?php   if (!$socialPost->twitter->settings['oauth_token']['value']) { ?>
		<div class="clearfix alert-message danger">
			<p><?php   echo t("You are not connected with Twitter."); ?></p>
			<p><?php   echo t("Please make sure that you are currently logged in with the Twitter account that you would like to connect to this site."); ?></p>
			<p>
				<input type="button" class="btn ccm-button-v2 primary" value="<?php   echo t("Authorize with Twitter"); ?>" onclick="location.href = '<?php   echo $socialPost->twitter->getAuthorizeURL(); ?>';">
			</p>
		</div>
	<?php   } else { ?>
		<div class="clearfix alert-message info">
			<p><?php   echo t("You are currently connected with Twitter."); ?></p>
            <p><?php   echo t('%1$s <a href="https://twitter.com/settings/applications" target="_blank">%2$s</a>.', "To remove authorization, click the 'Revoke Access' button on your", 'Twitter Applications page'); ?></p>
		</div>
		<?php   if (version_compare(APP_VERSION, '5.5.0', '>=')) { ?>
			<div class="clearfix">
				<label class="checkbox" style="text-align:left;width:auto" id="twitter_send_post">
					<input type="checkbox" name="twitter[send_post]" value="1" <?php   if ($socialPost->twitter->settings['send_post']['value'] == 1) { ?> checked <?php   } ?> />
					<?php   echo t('Post to Twitter when a new composer page is added') ?>
				</label>
			</div>
			<div id="send_post_on_twitter_div" style="margin-left:21px;<?php   if ($socialPost->twitter->settings['send_post']['value'] != 1) { ?>display:none;<?php   } ?>">
				<?php   $twitterPrefixes = Loader::helper('json')->decode($socialPost->twitter->settings['prefix']['value']); ?>
				<table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
					<thead>
						<tr>
							<th><?php   echo t("Page Type"); ?></th>
							<th><?php   echo t("Intro Text"); ?></th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><i><?php   echo t("Default"); ?></i></td>
							<td><input type="text" name="twitter[prefix][0]" value="<?php  
								$index = 0;
								$defaultTwitterPrefix = $twitterPrefixes->$index;
								echo $defaultTwitterPrefix;
								?>" style="width:145px;"></td>
						</tr>
						<?php  
						foreach ($composerPageTypes as $cpt) {
							$index = $cpt->ctID;
							$value = (isset($twitterPrefixes->$index)) ? $twitterPrefixes->$index : $defaultTwitterPrefix;
							?>
							<tr>
								<td><?php   echo $cpt->ctName; ?></td>
								<td><input type="text" name="twitter[prefix][<?php   echo $index; ?>]" value="<?php   echo $value; ?>" style="width:145px;"></td>
							</tr>
						<?php   } ?>
					</tbody>
				</table>
				<div class="clearfix">
					<label class="checkbox" style="margin-left:0;text-align:left;width:auto;">
						<input type="checkbox" name="twitter[use_hashtags]" value="1" <?php   if ($socialPost->twitter->settings['use_hashtags']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('Add Hashtags at the end of the tweet') ?>
					</label>
				</div>
			</div>

		<?php   } ?>
		<div class="clearfix" style="padding-bottom:0;"><hr></div>
		<div class="clearfix">
			<label class="checkbox" style="text-align:left;width:auto;" id="twitter_promote">
				<input type="checkbox" name="twitter[allow_promotion]" value="1" <?php   if ($socialPost->twitter->settings['allow_promotion']['value'] == 1) { ?> checked <?php   } ?> />
				<?php   echo t('Allow page editors to promote pages via Twitter') ?>
			</label>
		</div>
		<div id="promote_on_twitter_div" style="margin-left:21px;<?php   if ($socialPost->twitter->settings['allow_promotion']['value'] != 1) { ?>display:none;<?php   } ?>">
			<table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
				<thead>
					<tr>
						<th><?php   echo t("Intro Text"); ?></th>
					</tr>
				</thead>
				<tbody>
					<tr>
						<td><input type="text" name="twitter[promote_prefix]" value="<?php   echo $socialPost->twitter->settings['promote_prefix']['value']; ?>"></td>
					</tr>
				</tbody>
			</table>
			<div class="clearfix">
				<label class="checkbox" style="margin-left:0;text-align:left;width:auto;">
					<input type="checkbox" name="twitter[promote_default]" value="1" <?php   if ($socialPost->twitter->settings['promote_default']['value'] == 1) { ?> checked <?php   } ?> />
					<?php   echo t('By default, check the box for promoting pages via Twitter') ?>
				</label>
			</div>
			<div class="clearfix">
				<label class="checkbox" style="margin-left:0;text-align:left;width:auto;">
					<input type="checkbox" name="twitter[use_hashtags_promote_default]" value="1" <?php   if ($socialPost->twitter->settings['use_hashtags_promote_default']['value'] == 1) { ?> checked <?php   } ?> />
					<?php   echo t('By default, check the box for adding hashtags to the tweet') ?>
				</label>
			</div>
		</div>
	<?php   } ?>
</div>	

<script>
	$(function() {
		$('#sbs_sp_twitter_use').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#use_on_twitter_div').slideDown();
			} else {
				$('#use_on_twitter_div').slideUp();
			}
		});
		$('#twitter_send_post').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#send_post_on_twitter_div').slideDown();
			} else {
				$('#send_post_on_twitter_div').slideUp();
			}
		});
		$('#twitter_promote').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#promote_on_twitter_div').slideDown();
			} else {
				$('#promote_on_twitter_div').slideUp();
			}
		});
	});
</script>