<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */
?> 
<div class="clearfix">
	<label class="checkbox" id="use_on_facebook" style="text-align:left;width:auto;">
		<input type="checkbox" name="facebook[use]" value="1" <?php   if ($socialPost->facebook->settings['use']['value'] == 1) { ?> checked <?php   } ?> />
		<?php   echo t('Allow posts to Facebook') ?>
	</label>
</div>

<div id="use_on_facebook_div" style="<?php   if ($socialPost->facebook->settings['use']['value'] != 1) { ?>display:none;<?php   } ?>">
	<?php   if (!$socialPost->facebook->settings['app_id']['value'] || !$socialPost->facebook->settings['app_secret']['value']) { ?>
		<div class="clearfix alert-message danger">
			<p>You haven't entered an AppID and App Secret.</p>
			<p>You can create a Facebook App at <a href="https://developers.facebook.com/apps" target="_blank">Facebook Apps</a>.</p>
		</div>
	<?php   } ?>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="Application ID" >
			<input type="text" name="facebook[app_id]" value="<?php   echo $socialPost->facebook->settings['app_id']['value']; ?>" style="width:225px;"><span class="add-on">AppID</span>
		</div>
	</div>
	<div class="clearfix">
		<div class="input input-prepend" style="margin-left:0;" title="Application Secret" >
			<input type="text" name="facebook[app_secret]" value="<?php   echo $socialPost->facebook->settings['app_secret']['value']; ?>" style="width:195px;"><span class="add-on">App Secret</span>
		</div>
	</div>

	<?php   if ($socialPost->facebook->settings['app_id']['value'] && $socialPost->facebook->settings['app_secret']['value']) { ?>
		<?php   if (!$socialPost->facebook->settings['oauth_token']['value']) { ?>
			<div class="clearfix alert-message danger">
				<p>You are not connected with Facebook.</p>
				<p>Please make sure that you are currently logged in with the Facebook account that you would like to connect to this site.</p>
				<p>
					<input type="button" class="btn ccm-button-v2 primary" value="Authorize with Facebook" onclick="location.href = '<?php   echo $socialPost->facebook->getAuthorizeUrl(); ?>';">
				</p>
			</div>
			<?php  
		} elseif (!$socialPost->facebook->getTimeline()) {
			$pages = $socialPost->facebook->getUserTimelines();
			?>
			<div class="clearfix alert-message dancer">
				<p>You are currently connected with Facebook, but do not have a timeline selected. Please choose a timeline:</p>
				<select name="facebook[post_to_page]">
					<option value=""></option>
					<option value="<?php   echo $socialPost->facebook->user; ?>">My Timeline</option>
					<?php   foreach ($pages as $page) { ?>
						<option value="<?php   echo $page['page_id']; ?>"><?php   echo $page['name']; ?></option>	
					<?php   } ?>
				</select>
				<ol>
					<li>Choose a timeline above</li>
					<li>Click the 'Update My Settings' button above.</li>
				</ol>
			</div>

			<?php  
		} else {
			$timeline = $socialPost->facebook->getTimeline();
			?>
			<div class="clearfix alert-message info">
				<p>You are currently connected with Facebook and posting to <?php   echo $timeline['name']; ?>.</p>
				<p id="chooseTimeline" style="cursor:pointer;text-decoration:underline;">Choose a new timeline</p>
				<div id="chooseTimelineInstructions" style="display:none;">
					<ol>
						<li>Delete the AppId and App Secret above</li>
						<li>Click the 'Update My Settings' button above.</li>
					</ol>
				</div>
				<p id="removeAuthorization" style="cursor:pointer;text-decoration:underline;">Remove authorization</p>
				<div id="removeAuthorizationInstructions" style="display:none;">
					<ol>
						<li>Click the 'Remove' icon on your <a href="https://www.facebook.com/settings?tab=applications" target="_blank">Facebook Apps Settings page</a>.</li>
						<li>Click the 'Update My Settings' button above.</li>
					</ol>
				</div>
			</div>
			<input type="hidden" name="facebook[post_to_page]" value="<?php   echo $timeline['id']; ?>">
			<input type="hidden" name="facebook[post_to_page_name]" value="<?php   echo $timeline['name']; ?>">
			<?php   if (version_compare(APP_VERSION, '5.5.0', '>=')) { ?>
				<div class="clearfix">
					<label class="checkbox" style="width:auto;text-align:left;" id="facebook_send_post">
						<input type="checkbox" name="facebook[send_post]" value="1" <?php   if ($socialPost->facebook->settings['send_post']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('Post to facebook when a new composer page is added') ?>
					</label>
				</div>
				<div id="send_post_on_facebook_div" style="margin-left:21px;<?php   if ($socialPost->facebook->settings['send_post']['value'] != 1) { ?>display:none;<?php   } ?>">
					<?php   $facebookPrefixes = Loader::helper('json')->decode($socialPost->facebook->settings['prefix']['value']); ?>
					<table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
						<thead>
							<tr>
								<th>Page Type</th>
								<th>Intro Text</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><i>Default</i></td>
								<td><input type="text" name="facebook[prefix][0]" value="<?php  
									$index = 0;
									$defaultfacebookPrefix = $facebookPrefixes->$index;
									echo $defaultfacebookPrefix;
									?>"></td>
							</tr>
							<?php  
							foreach ($composerPageTypes as $cpt) {
								$index = $cpt->ctID;
								$value = (isset($facebookPrefixes->$index)) ? $facebookPrefixes->$index : $defaultfacebookPrefix;
								?>
								<tr>
									<td><?php   echo $cpt->ctName; ?></td>
									<td><input type="text" name="facebook[prefix][<?php   echo $index; ?>]" value="<?php   echo $value; ?>"></td>
								</tr>
							<?php   } ?>
						</tbody>
					</table>
					<div class="clearfix">
						<label class="checkbox" style="margin-left:0;width:auto;text-align:left;">
							<input type="checkbox" name="facebook[use_hashtags]" value="1" <?php   if ($socialPost->facebook->settings['use_hashtags']['value'] == 1) { ?> checked <?php   } ?> />
							<?php   echo t('Add Hashtags at the end of the post') ?>
						</label>
					</div>
				</div>
				<?php  
			}
		}
	}
	?> 
</div>
<script>
	$(function() {
		$('#use_on_facebook').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#use_on_facebook_div').slideDown();
			} else {
				$('#use_on_facebook_div').slideUp();
			}
		});
		$('#facebook_post_to_page').bind('change', function() {
			if ($(this).val() != '') {
				$('#facebook_post_settings_div').slideDown();
			} else {
				$('#facebook_post_settings_div').slideUp();
			}
		});
		$('#facebook_send_post').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#send_post_on_facebook_div').slideDown();
			} else {
				$('#send_post_on_facebook_div').slideUp();
			}
		});
		$('#chooseTimeline').bind('click', function() {
			$('#use_on_facebook_div #chooseTimelineInstructions').slideToggle();
		});
		$('#removeAuthorization').bind('click', function() {
			$('#use_on_facebook_div #removeAuthorizationInstructions').slideToggle();
		});
	});
</script>