<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */
?> 
<div class="clearfix">
	<label class="checkbox" id="sbs_sp_twitter_use" style="text-align:left;">
		<input type="checkbox" name="twitter[use]" value="1" <?php   if (($socialPost->twitter->settings['connected']['value'] == 1) && ($socialPost->twitter->settings['use']['value'] == 1)) { ?> checked <?php   } ?> />
		<?php   echo t('Allow Posts to Twitter') ?>
	</label>
</div>
<div id="use_on_twitter_div" style="<?php   if (($socialPost->twitter->settings['connected']['value'] != 1) || ($socialPost->twitter->settings['use']['value'] != 1)) { ?>display:none;<?php   } ?>">
	<?php   if (!$socialPost->twitter->settings['oauth_token']['value']) { ?>
		<div class="clearfix alert-message danger">
			<p>You are not connected with Twitter.</p>
			<p>Please make sure that you are currently logged in with the Twitter account that you would like to connect to this site.</p>
			<p>
				<input type="button" class="btn ccm-button-v2 primary" value="Authorize with Twitter" onclick="location.href = '<?php   echo $socialPost->twitter->getAuthorizeURL(); ?>';">
			</p>
		</div>
	<?php   } else { ?>
		<div class="clearfix alert-message info">
			<p>You are currently connected with Twitter.</p>
			<p>To remove authorization, click the 'Revoke Access' button on your <a href="https://twitter.com/settings/applications" target="_blank">Twitter Applications page</a>.
		</div>
		<?php   if (version_compare(APP_VERSION, '5.5.0', '>=')) { ?>
			<div class="clearfix">
				<label class="checkbox" style="text-align:left;width:auto" id="twitter_send_post">
					<input type="checkbox" name="twitter[send_post]" value="1" <?php   if ($socialPost->twitter->settings['send_post']['value'] == 1) { ?> checked <?php   } ?> />
					<?php   echo t('Post to Twitter when a new composer page is added') ?>
				</label>
			</div>
			<div id="send_post_on_twitter_div" style="margin-left:21px;<?php   if ($socialPost->twitter->settings['send_post']['value'] != 1) { ?>display:none;<?php   } ?>">
				<?php   $twitterPrefixes = Loader::helper('json')->decode($socialPost->twitter->settings['prefix']['value']); ?>
				<table border="0" cellspacing="0" cellpadding="0" class="zebra-striped">
					<thead>
						<tr>
							<th>Page Type</th>
							<th>Intro Text</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><i>Default</i></td>
							<td><input type="text" name="twitter[prefix][0]" value="<?php  
								$index = 0;
								$defaultTwitterPrefix = $twitterPrefixes->$index;
								echo $defaultTwitterPrefix;
								?>" style="width:145px;"></td>
						</tr>
						<?php  
						foreach ($composerPageTypes as $cpt) {
							$index = $cpt->ctID;
							$value = (isset($twitterPrefixes->$index)) ? $twitterPrefixes->$index : $defaultTwitterPrefix;
							?>
							<tr>
								<td><?php   echo $cpt->ctName; ?></td>
								<td><input type="text" name="twitter[prefix][<?php   echo $index; ?>]" value="<?php   echo $value; ?>" style="width:145px;"></td>
							</tr>
							<?php  
						}
						?>
					</tbody>
				</table>
				<div class="clearfix">
					<label class="checkbox" style="margin-left:0;text-align:left;width:auto;">
						<input type="checkbox" name="twitter[use_hashtags]" value="1" <?php   if ($socialPost->twitter->settings['use_hashtags']['value'] == 1) { ?> checked <?php   } ?> />
						<?php   echo t('Add Hashtags at the end of the tweet') ?>
					</label>
				</div>
			</div>
			<?php  
		}
	}
	?>
</div>	

<script>
	$(function() {
		$('#sbs_sp_twitter_use').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#use_on_twitter_div').slideDown();
			} else {
				$('#use_on_twitter_div').slideUp();
			}
		});
		$('#twitter_send_post').bind('click', function() {
			var $input = $(this).find('INPUT');
			if ($input.is(':checked')) {
				$('#send_post_on_twitter_div').slideDown();
			} else {
				$('#send_post_on_twitter_div').slideUp();
			}
		});
	});
</script>