<?php  

defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

class SocialIconHelper
{

	var $dimensions = array('width' => null, 'height' => null);

	function defaultExists($handle, $size)
	{
		if (is_numeric($size)) {
			$size = $size . 'x' . $size;
		}

		if (file_exists(DIR_FILES_BLOCK_TYPES . "/skybluesofa_social_connect/img/" . $handle . "-" . $size . ".png")) {
			return true;
		} elseif (file_exists(DIR_PACKAGES . "/skybluesofa_social_share/img/" . $handle . "-" . $size . ".png")) {
			return true;
		} else {
			return false;
		}
	}

	function getSize($handle, $size, $defaults = false, $resizeTo = false)
	{
		if (!$defaults) {
			$db = Loader::db();
			$sql = "SELECT *
			FROM btSkybluesofaSocialNetworks
			WHERE id IN (SELECT MAX(id)
				       FROM btSkybluesofaSocialNetworks
				       GROUP by handle) AND share=1 AND handle LIKE ?
			GROUP BY handle";
			$exists = $db->GetRow($sql, array($handle));
			if ($exists['id']) {
				if ($exists['icon_' . strtolower($size)]) {
					Loader::helper('file');
					$ih = Loader::helper('image');
					$icon = File::getByID($exists['icon_' . $size]);
					if ($size == 'custom' && !$resizeTo) {
						$imageSize = getimagesize($icon->getPath());
						$this->dimensions['width'] = $imageSize[0];
						$this->dimensions['height'] = $imageSize[1];
					} else {
						if ($resizeTo) {
							$thumb = $ih->getThumbnail($icon, $resizeTo, $resizeTo, false);
						} else {
							$thumb = $ih->getThumbnail($icon, $size, $size, true);
						}
						$this->dimensions['width'] = $thumb->width;
						$this->dimensions['height'] = $thumb->height;
					}
					return $this->dimensions;
				}
			}
		}
		$this->dimensions['width'] = $size;
		$this->dimensions['height'] = $size;
		return $this->dimensions;
	}

	function getUrl($handle, $size, $defaults = false, $resizeTo = false)
	{
		$size = strtolower($size);
		$src = false;
		if (!$defaults) {
			$db = Loader::db();
			$sql = "SELECT *
				FROM btSkybluesofaSocialNetworks
				WHERE id IN (SELECT MAX(id)
					FROM btSkybluesofaSocialNetworks
					GROUP by handle) AND handle LIKE ?";
			$exists = $db->GetRow($sql, array($handle));
			if ($exists['id']) {
				if ($exists['icon_' . $size]) {
					Loader::helper('file');
					$ih = Loader::helper('image');
					$icon = File::getByID($exists['icon_' . $size]);
					if ($size == 'custom' && !$resizeTo) {
						$src = $icon->getRelativePath();
						$imageSize = getimagesize($icon->getPath());
						$this->dimensions['width'] = $imageSize[0];
						$this->dimensions['height'] = $imageSize[1];
					} else {
						if ($resizeTo) {
							$thumb = $ih->getThumbnail($icon, $resizeTo, $resizeTo, false);
						} else {
							$thumb = $ih->getThumbnail($icon, $size, $size, true);
						}
						$src = $thumb->src;
						$this->dimensions['width'] = $thumb->width;
						$this->dimensions['height'] = $thumb->height;
					}
				}
			}
		}
		if ($src) {
			return $src;
		} else {
			if (is_numeric($size)) {
				$size = $size . 'x' . $size;
			}

			if (file_exists(DIR_FILES_BLOCK_TYPES . "/skybluesofa_social_connect/img/" . $handle . "-" . $size . ".png")) {
				return DIR_REL . "/blocks/skybluesofa_social_connect/img/" . $handle . "-" . $size . ".png";
			} elseif (file_exists(DIR_PACKAGES . "/skybluesofa_social_share/img/" . $handle . "-" . $size . ".png")) {
				return DIR_REL . "/packages/skybluesofa_social_share/img/" . $handle . "-" . $size . ".png";
			} else {
				return false;
			}
		}
	}

	function getTag($handle, $size, $defaults = false, $resizeTo = false)
	{
		return '<img src="' . $this->getURL($handle, $size, $defaults, $resizeTo) . '" style="width:' . $this->dimensions['width'] . ';height:' . $this->dimensions['height'] . ';">';
	}

}
