<?php  

defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

Loader::library('3rdParty/twitteroauth/twitteroauth', 'skybluesofa_social_share');
Loader::model('social_post/network', 'skybluesofa_social_share');

class TwitterSocialPost
		extends NetworkSocialPost
{

	public $settingsGroupName = 'twitter';
	private $requestTokenUrl = 'https://api.twitter.com/oauth/request_token';
	private $accessTokenUrl = 'https://api.twitter.com/oauth/access_token';
	private $authorizeUrl = 'https://api.twitter.com/oauth/authorize';
	private $verifyUrl = 'https://api.twitter.com/1.1/account/verify_credentials.json';
	protected $callbackURL = '';

	function __construct()
	{
		parent::__construct();

		$this->consumer_key = 'Wh9sA14coEviOc1Kixciw';
		$this->consumer_secret = 'JemoytDFrWRKSUmK2kWzKmVKKByG3ouHJmy6HBMYnOE';
		//$this->consumer_key = $this->settings['consumer_key']['value'];
		//$this->consumer_secret = $this->settings['consumer_secret']['value'];
		$this->oauth_token = $this->settings['oauth_token']['value'];
		$this->oauth_secret = $this->settings['oauth_token_secret']['value'];
		$this->callbackURL = BASE_URL . DIR_REL . $this->callbackURL;
	}

	public function getSettings()
	{
		//$this->settings['consumer_key'] = array('title' => 'Consumer Key', 'value' => $this->consumer_key);
		//$this->settings['consumer_secret'] = array('title' => 'Consumer Secret', 'value' => $this->consumer_secret);
		return $this->settings;
	}

	public function getTwitter()
	{
		if ($this->instance) {
			return $this->instance;
		}
		$this->instance = new SocialShareTwitter_OAuth($this->consumer_key, $this->consumer_secret, $this->settings['oauth_token']['value'], $this->settings['oauth_token_secret']['value']);
		if (!is_a($this->instance, "SocialShareTwitter_OAuth")) {
			$this->updateCredentials(false, false);
			$this->instance = false;
		}
		return $this->instance;
	}

	public function isRevoked()
	{
		$this->getTwitter();
		if (method_exists($this->instance, 'get')) {
			$this->instance->get($this->verifyUrl);
			if ($this->instance->http_code != '200') {
				$this->removeCredentials();
				return true;
			}
		}
		return false;
	}

	public function removeCredentials()
	{
		$this->updateCredentials(null, null);
		$this->getSettingsFromDB();
	}

	public function saveCredentials()
	{
		// Twitter connection
		$oauth_token = $_REQUEST['oauth_token'];
		$oath_verifier = $_REQUEST['oauth_verifier'];
		$oauth = new SocialShareTwitter_OAuth($this->consumer_key, $this->consumer_secret, $_SESSION['tw_temp_creds']['oauth_token'], $_SESSION['tw_temp_creds']['oauth_token_secret']);
		$credentials = $oauth->getAccessToken($_REQUEST['oauth_verifier']);
		if (isset($credentials['oauth_token']) && isset($credentials['oauth_token_secret'])) {
			$this->updateCredentials($credentials['oauth_token'], $credentials['oauth_token_secret']);
			$returnValue = true;
		} else {
			$returnValue = false;
		}
		unset($_SESSION['tw_temp_creds']);
		return $returnValue;
	}

	public function updateCredentials($oauth_token, $oauth_token_secret)
	{
		$this->saveSetting('oauth_token', $oauth_token);
		$this->saveSetting('oauth_token_secret', $oauth_token_secret);
		if ($oauth_token && $oauth_token_secret) {
			$connected = 1;
			$this->saveSetting('use', '1');
		} else {
			$connected = 0;
		}
		$this->saveSetting('connected', $connected);
	}

	public function getAuthorizeURL()
	{
		unset($_SESSION['tw_temp_creds']);
		$twitterOauth = new SocialShareTwitter_OAuth($this->consumer_key, $this->consumer_secret);
		$temp = $twitterOauth->getRequestToken($this->callbackURL);
		$_SESSION['tw_temp_creds'] = $temp;
		$url = $twitterOauth->getAuthorizeURL($temp);
		return $url;
	}

	protected function generatePostContents()
	{
		$prefix = trim($this->prefix);
		if (strlen($prefix))
			$prefix .= ' ';
		if ($this->hashTags) {
			$this->hashTags = " " . $this->hashTags;
		}
		$postContents = false;
		// Create an array of possible tweets, starting with the longest and going to the shortest
		$testTexts = array();
		$testTexts[] = $prefix . $this->pageName . ' ' . $this->pageUrl . $this->hashTags;
		$testTexts[] = $prefix . $this->pageName . ' ' . $this->pageShortUrl . $this->hashTags;

		if ($this->hashTags) {
			// Remove the hash tags one by one until we dont have any left
			$ht = explode(' ', $this->hashTags);
			$numberHT = count($ht);
			for ($i = 1; $i < $numberHT; $i++) {
				array_pop($ht);
				$testTexts[] = $prefix . $this->pageName . ' ' . $this->pageUrl . ' ' . implode(' ', $ht);
				$testTexts[] = $prefix . $this->pageName . ' ' . $this->pageShortUrl . ' ' . implode(' ', $ht);
			}
		}
		// Create the four shortest ones
		$testTexts[] = $prefix . $this->pageName . ' ' . $this->pageUrl;
		$testTexts[] = $prefix . $this->pageName . ' ' . $this->pageShortUrl;
		$testTexts[] = $prefix . $this->pageUrl;
		$testTexts[] = $prefix . $this->pageShortUrl;
		foreach ($testTexts as $testText) {
			if (strlen($testText) <= 140) {
				$postContents = $testText;
				break;
			}
		}
		return $postContents;
	}

	protected function postToNetwork($postContents)
	{
		$success = false;
		Log::addEntry('Network Settings: ' . print_r($this->settings, true), 'Socializer');
		if (is_array($this->settings) && $this->settings['connected']['value'] && $this->settings['use']['value']) {
			$this->getTwitter();
			Log::addEntry('Attempting to post to twitter', 'Socializer');
			$response = $this->instance->post('statuses/update', array('status' => $postContents));
			Log::addEntry(print_r($response, true), 'Socializer');
			$success = true;
			Log::addEntry('Page posted to Twitter: ' . print_r($postContents, true), 'Socializer');
		}
		return $success;
	}

}

?>