<?php 
defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

Loader::model('site/social_post', 'skybluesofa_social_share');

$uh = Loader::helper('concrete/urls');
$h = Loader::helper('concrete/interface');
$vt = Loader::helper('validation/token');

$cdh = Loader::helper('concrete/dashboard');
echo $cdh->getDashboardPaneHeaderWrapper(t('Social Promotion'), t('Configure the way that Composer pages send out notices and Page Promotion is handled.'), false, false);
$socialPost = new SiteSocialPost();
?>
<form method="post" id="skybluesofa_social_promotion_form"
      action="<?php  echo $this->url('/dashboard/composer/social_post', 'save') ?>">
    <?php  echo $vt->output('social_networks'); ?>
    <input name="section" value="social_networks" type="hidden">

    <div class="ccm-pane-body">
        <?php  $elementVars = array('socialPost' => $socialPost, 'composerPageTypes' => $composerPageTypes) ?>
        <table style="width:918px;">
            <tr>
                <td style="width:292px;vertical-align:top;padding-right:21px;">
                    <?php  Loader::packageElement('post_settings/site/twitter', 'skybluesofa_social_share', $elementVars); ?>
                </td>
                <td style="width:292px;vertical-align:top;padding-right:21px;">
                    <?php  Loader::packageElement('post_settings/site/facebook', 'skybluesofa_social_share', $elementVars); ?>
                </td>
                <td style="width:292px;vertical-align:top;">
                    <?php  Loader::packageElement('post_settings/site/linkedin', 'skybluesofa_social_share', $elementVars); ?>
                </td>
            </tr>
        </table>
    </div>
    <div class="ccm-pane-footer">
        <div class="ccm-buttons">
            <input type="button" class="btn ccm-button-v2 primary ccm-button-v2-right"
                   value="Update Social Network Settings" id="add-skybluesofa_social_promotion_form_submit"
                   name="add-skybluesofa_social_promotion_submit">
        </div>
    </div>
</form>
</div></div></div>
<br>
<br>

<?php 

echo $cdh->getDashboardPaneHeaderWrapper(t('Social Configuration'), t('Configure metadata for social networks.'), false, false);
?>
<form method="post" id="skybluesofa_social_configuration_form"
      action="<?php  echo $this->url('/dashboard/composer/social_post', 'save_configuration') ?>">
    <?php  echo $vt->output('social_configuration'); ?>
    <input name="section" value="social_configuration" type="hidden">
    <div class="ccm-pane-body">
        <?php  Loader::packageElement('configuration', 'skybluesofa_social_share', array('socialConfiguration'=>$socialConfiguration)); ?>
    </div>
    <div class="ccm-pane-footer">
        <div class="ccm-buttons">
            <input type="button" class="btn ccm-button-v2 primary ccm-button-v2-right"
                   value="Update Social Configuration" id="add-skybluesofa_social_configuration_form_submit"
                   name="add-skybluesofa_social_configuration_submit">
        </div>
    </div>
</form>
</div></div></div>
<script>
    $(function () {
        $('#add-skybluesofa_social_promotion_form_submit').bind('click', function () {
            $('#skybluesofa_social_promotion_form').submit();
        });
        $('#add-skybluesofa_social_configuration_form_submit').bind('click', function () {
            $('#skybluesofa_social_configuration_form').submit();
        });
    });
</script>
