<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));
/*
 * Socializer for c5
 *
 * @package Block Quoter
 * @author Dave Rogers <connect@skybluesofa.com>
 * @version 5.6.0.0.5.3
 * @copyright Copyright (c) 2014, Dave Rogers
 * @license http://www.concrete5.org/help/legal/commercial_add-on_license/ c5 Commercial Add-On License
 */

Loader::helper('file');
$sih = Loader::helper('social_icon', 'skybluesofa_social_share');

$db = Loader::db();

$networks = $db->GetArray("SELECT *
				FROM btSkybluesofaSocialNetworks
				WHERE id IN (SELECT MAX(id)
					FROM btSkybluesofaSocialNetworks
					GROUP by handle) AND handle LIKE ?
				ORDER BY name");

if (isset($_POST['update'])) {
	$sql = "UPDATE btSkybluesofaSocialNetworks SET name=?, tooltip=?, active=?, show_existing=? WHERE id=?";
	foreach ($networks as $network) {
		$db->execute($sql, array($_POST['name'][$network['id']], $_POST['tooltip'][$network['id']], isset($_POST['active'][$network['id']]) ? 1 : 0, isset($_POST['show_existing'][$network['id']]) ? 1 : 0, $network['id']));
	}
	die(Loader::helper('json')->encode($_POST));
} else {
	$uh = Loader::helper('concrete/urls');
	?>
	<div class="ccm-ui" id="ccm-custom-style-wrapper">
		<script>
			$(function() {
				$('#active_all').bind('click', function() {
					if ($(this).is(":checked")) {
						$('.active_network').attr('checked', 'checked');
					} else {
						$('.active_network').attr('checked', false);
					}
				});
				$('#show_existing_all').bind('click', function() {
					if ($(this).is(":checked")) {
						$('.show_existing_network').attr('checked', 'checked');
					} else {
						$('.show_existing_network').attr('checked', false);
					}
				});
				$('.active_network').bind('click', function() {
					if (!$(this).is(":checked")) {
						$('#active_all').attr('checked', false);
					}
				});
				$('.show_existing_network').bind('click', function() {
					if (!$(this).is(":checked")) {
						$('#show_existing_all').attr('checked', false);
					}
				});
			});
			function saveNetworkChecks() {
				formdata = $('#skybluesofa_social_share_network_checks_form').serialize();
				$.ajax({
					type: "POST",
					data: formdata,
					dataType: 'json',
					url: $('#skybluesofa_social_share_network_checks_form').attr('action'),
					success: function(data) {
						if (data.error) {
							alert(data.error);
						} else {
							for (rowid in data.name) {
								if (data.active[rowid] && data.show_existing[rowid]) {
									$('#skybluesofa_social_network_row_' + rowid + ' TD').removeClass('red');
								} else {
									$('#skybluesofa_social_network_row_' + rowid + ' TD').addClass('red');
								}
								$('#skybluesofa_social_network_row_' + rowid + ' TD.name').html(data.name[rowid]);
								$('#skybluesofa_social_network_row_' + rowid + ' TD.icontooltip').html(data.tooltip[rowid]);
							}
							jQuery.fn.dialog.closeTop();
						}
					},
					error: function() {
						alert('there was an error');
					}
				});
				return false;
			}
		</script>
		<form method="POST" id="skybluesofa_social_share_network_checks_form" action="<?php   echo $uh->getToolsURL('edit_all_networks', 'skybluesofa_social_share'); ?>">
			<input type="hidden" name="update">
			<table cellspacing="0" cellpadding="0" style="width:100%;" class="zebra-striped ccm-results-list table">
				<thead>
					<tr>
						<th><?php   echo t('Name'); ?></th>
						<th><?php   echo t('Tooltip'); ?></th>
						<th title="<?php   echo t('Allow adding to new blocks'); ?>"><input type="checkbox" value="1" name="active_all" id="active_all"> <?php   echo t('Is Active'); ?></th>
						<th title="<?php   echo t('Show network in current blocks if exists'); ?>"><input type="checkbox" value="1" name="show_existing_all" id="show_existing_all"> <?php   echo t('Keep in current'); ?></th>
					</tr>
				</thead>
				<tbody>
					<?php   foreach ($networks as $key => $network) { ?>
						<tr>
							<td><input type="text" value="<?php   echo $network['name']; ?>" name="name[<?php   echo $network['id']; ?>]" style="width:150px;"></td>
							<td><input type="text" value="<?php   echo $network['tooltip']; ?>" name="tooltip[<?php   echo $network['id']; ?>]" style="width:150px;"></td>
							<td><input type="checkbox" value="1" class="active_network" name="active[<?php   echo $network['id']; ?>]" <?php   echo ($network['active'] ? 'checked="checked"' : ''); ?>></td>
							<td><input type="checkbox" value="1" class="show_existing_network" name="show_existing[<?php   echo $network['id']; ?>]" <?php   echo ($network['show_existing'] ? 'checked="checked"' : ''); ?>></td>
						</tr>
					<?php   } ?>
				</tbody>
			</table>
		</form>
	</div>
	<div class="dialog-buttons">
		<a href="#" class="btn ccm-button-left cancel" onclick="jQuery.fn.dialog.closeTop();
				return false;"><?php   echo t('Cancel') ?></a>
		<a href="#" onclick="saveNetworkChecks();
				return false;" class="ccm-button-right accept btn primary"><?php   echo t('Save') ?></a>
	</div>

	<?php  
} 
